import { changeTrapezoidPlace, changeCircle, getPlaceXY } from './changeImage'
var createEl, drawBox, box, temp, dir, storageMark = {}, moveShortX, moveShortY;
var dx = 0; // 获取鼠标按下的盒子某个位置的相对浏览器可视区域坐标
var sx = 0; // 获取原始

/**
 * 旋转使用变量
 */
var route;
var centerX = 0 // 默认旋转的中心点
var centerY = 0
var debug = false // 默认旋转的中心点
var dis = 0
// 旋转时重新计宽高
var rotateoffsetWidth, rotateoffsetHeight;

/**
 * 实例化函数
 * @param changeTrapezoid   梯形坐标改变
 * @param Circle            圆坐标改变
 * @param placeXY           获取坐标构造函数
 */
var changeTrapezoid = new changeTrapezoidPlace()
var Circle = new changeCircle()
var placeXY = new getPlaceXY()
/**
 * 操作函数
 * @param mobile          类，操作
 * @param coordinate      获取坐标
 * @param drawTable       鼠标松开开始获取与coordinate配合使用
 * @param givePlace       赋予拖动图像初始位置
 * @param mousedown       鼠标按下事件获取坐标，高亮等操作
 * @param mousemove       鼠标移动的方法
 * @param mousedownDom    获取要改变的元素
 * @param variablePointer 鼠标指针的判断
 * @param drawColumn      canvas旋转图
 * @param movehandle      旋转角度赋值
 * @param angle           计算旋转角度
 */
function start() {
    drawBox = document.getElementById('drawBox');
    box = document.querySelectorAll('.sidebar .box')
    var canvas = document.getElementById('myCanvas');
    // 获取当前点击位置的offset
    for(let i = 0;i<box.length;i++) {
        box[i].onmousedown = function (e) {
            dx = e.offsetX // 获取距离文档区域的
            sx = e.offsetY
        }
    }
    class mobile {
        constructor () {
            this.x = x
            this.y = y
            // 可调整动画函数
            this.offset = 30 // 缓冲距离，越大越快
            this.interval = 5 // 动画速度，越大越慢
            this.duration = 100 // 缓冲步数，越大越慢
        }
        // 获取坐标
        coordinate (e) {
            return {
              x : e.clientX,
              y : e.clientY
            }
        }
        // 鼠标松开，开始
        drawTable (e, node) {
            let place = this.coordinate(e)
            this.givePlace(node, place)
        }
        // 赋予拖动图像初始位置
        givePlace (node, place) {
            node.style.left = place.x - dx+ 'px'
            node.style.top = place.y - sx + 'px'
            node.style.position = 'absolute'
        }
        // 选中图形添加高亮
        mousedown (event) {
          let n = mobile.mousedownDom(event.target, "tagName", "SPAN")
          // 用户选中的是否为span
          if(n.tagName === 'SPAN') {
            // 计算旋转度数
            mobile.drawColumn(n)
            // 最后一个是不是canvas
            if(n.lastElementChild.tagName === 'CANVAS'){
                // 获取鼠标指针
               let str = mobile.variablePointer(n, event)
                if(str === 'wait') debug = true
            }
            // 拿到选中的元素用于旋转
            route = n
          }
          // 循环点击当前显示可操作边框
          let span = document.querySelectorAll('#drawBox span')
          for (let i = 0;i<span.length;i++) {
              if(n === span[i]){
                // 显示div
                span[i].firstElementChild.firstElementChild.style.display = 'block'
                // 旋转圆柱显示
                span[i].querySelector('.shape_rotater').style.display = 'block'
              } else {
                // 隐藏div
                span[i].firstElementChild.firstElementChild.style.display = 'none  '
                // 旋转圆柱隐藏
                span[i].querySelector('.shape_rotater').style.display = 'none'
              }
          }
          // 点击的不是span return
          if (n === null || n.tagName !== 'SPAN') {
            storageMark = null
            return
          }
          // 是否有鼠标指针
          dir = mobile.variablePointer(n, event)
          if (dir === "") return
          // 赋予图形的宽高，坐标距离
          storageMark = new getPlaceXY()
          storageMark.el = n // 选中的
          storageMark.dir = dir
          storageMark.grabx = window.event.clientX
          storageMark.graby = window.event.clientY
          storageMark.width = n.offsetWidth
          storageMark.height = n.offsetHeight
          storageMark.left = n.offsetLeft
          storageMark.top = n.offsetTop
          rotateoffsetWidth = n.offsetWidth
          rotateoffsetHeight = n.offsetHeight
          // 图形的唯一标识对应不同操作函数
          if(n.tagName === 'SPAN') {
            storageMark.name = n.attributes["name"].value
            // storageMark.minWidth = n.attributes["min-width"].value
          }
          // 梯形专用坐标获取
          placeXY.__proto__.trapezoid(storageMark, n.firstElementChild)
          // 计算移动坐标
          var mouseX = parseInt(placeXY.__proto__.getMouseXY(event).x),
              mouseY = parseInt(placeXY.__proto__.getMouseXY(event).y)
              // 拿到用户选择之后的差值
              moveShortX = mouseX - storageMark.left
              moveShortY = mouseY - storageMark.top
              drawBox.onmousemove = mobile.prototype.mousemove
          // 阻止冒泡
          window.event.returnValue = false
          window.event.cancelBubble = true
        }
        mousemove (e) {
            let str, xMin = 8, yMin = 8;
            let n = mobile.mousedownDom(event.target, "tagName", "SPAN")
            // 鼠标指针
            mobile.movehandle(e)
            if (n.tagName === "SPAN") {
                if (centerX === 0 && centerY === 0) {
                    centerX = n.offsetLeft + n.offsetWidth / 2
                    centerY = n.offsetTop + n.offsetHeight / 2
                }
                str = mobile.variablePointer(n, e)
                if(str === 'wait') {
                    e.target.classList.add('rotate_enable')  
                } else {
                    e.target.classList.remove('rotate_enable')
                    if (str === "move") str = "move"
                    else str += "-resize"
                    n.style.cursor = str
                }
            } else {
                n.style.cursor = ""
            }
            // 物体移动改变形状
            if (storageMark !==null) {
                // 整体移动
                if(storageMark.dir.indexOf("v") !== -1) {
                    debug = false
                    // 获取差值
                    var x = placeXY.__proto__.getMouseXY(e).x - moveShortX,
                    y = placeXY.__proto__.getMouseXY(e).y - moveShortY,
                    width = document.documentElement.clientWidth - storageMark.width,
                    height = document.documentElement.clientHeight - storageMark.height
                    // 拿到移动的位置
                    x = Math.min(Math.max(0, x), width)
                    y = Math.min(Math.max(0, y), height)
                    // 300 为左边距功能栏宽度， 做一下限制
                    storageMark.el.style.left = (x < 300 ? 300 : x) + 'px'
                    storageMark.el.style.top = y + 'px'
                } else {
                    // 旋转
                    if(storageMark.dir.indexOf("it") !== -1) {  
                    } else {
                        if(storageMark.dir.indexOf("e") !== -1) {
                            // width
                            if (storageMark.name === 'public' || storageMark.name === 'arc') {
                                Circle.__proto__.circleRightWidth(storageMark, xMin, yMin, storageMark.name)
                            }
                            if (storageMark.name === 'Trapezoid') {
                                changeTrapezoid.__proto__.trapezoidRight(storageMark, xMin, yMin)
                            }
                        }
                        if(storageMark.dir.indexOf("s") !== -1) {
                            // height
                            if (storageMark.name === 'public' || storageMark.name === 'arc') {
                                Circle.__proto__.circleHeight(storageMark, xMin, yMin, storageMark.name)
                            }
                            if (storageMark.name === 'Trapezoid') {
                                changeTrapezoid.__proto__.trapezoidBottom(storageMark, xMin, yMin)
                            }
                        }
                        if(storageMark.dir.indexOf("w") !== -1) {
                            // width left
                            if (storageMark.name === 'public' || storageMark.name === 'arc') {
                                Circle.__proto__.circleWidth(storageMark, xMin, yMin, storageMark.name)
                            }
                            if (storageMark.name === 'Trapezoid') {
                                changeTrapezoid.__proto__.trapezoidLeft(storageMark, xMin, yMin)
                            }
                            
                        }
                        if(storageMark.dir.indexOf("n") !== -1) {
                            // top height
                            if (storageMark.name === 'public' || storageMark.name === 'arc') {
                                Circle.__proto__.circleTopHeight(storageMark, xMin, yMin, storageMark.name)
                            }
                            if (storageMark.name === 'Trapezoid') {
                                changeTrapezoid.__proto__.trapezoidTopHeight(storageMark, xMin, yMin)
                            }
                        }
                    }
                }
            }
        }
        // 获取要改变的dom
        static mousedownDom(el, type, value) {
            temp = el;
            while ((temp !== null) && (temp.tagName !== "BODY")) {
                if (eval("temp." + type) === value) {
                    el = temp;
                    return el;
                }
                temp = temp.parentElement;
            }
            return temp;
        }
        // 获取offset 改变鼠标指针
        static variablePointer(el, e) {
            var  dir, deg = el.style.transform.replace(/[^0-9.]/ig,"")
            deg = deg ? deg : 0
            // 根据坐标大小添加鼠标指针
            if(el.tagName === 'SPAN'){
                if (e.srcElement.nodeName === 'CANVAS' && e.offsetY < 23) {
                    dir = "wait"
                    return dir
                }
                if (e.target.className === 'mouse-first') {
                    dir = "nw"
                } else if (e.target.className === 'mouse-second') {
                    dir = "ne"
                } else if (e.target.className === 'mouse-third') {
                    dir = "se"
                } else if (e.target.className === 'mouse-fourth') {
                    dir = "sw"
                } else {
                    dir = "move"
                }
                return dir
            }
        }
        // 绘制旋转图
        static drawColumn (e) {
            var imageCanvas = e.lastElementChild
            var ctx = imageCanvas.getContext("2d")
            ctx.beginPath()
            ctx.arc(10,15,5,0,2*Math.PI)
            ctx.moveTo(10,20)
            ctx.lineTo(10,60)
            ctx.strokeStyle="peru"
            ctx.stroke()
        }
        // 旋转角度赋值
        static movehandle (e) {
            dis = mobile.angle(centerX, centerY, e.clientX, e.clientY)
            if (debug) {
                route.style.transform = `rotateZ(${parseInt(dis)}deg)`
                let transform = window.getComputedStyle(route)['transform'],
                    matrix = transform.slice(7, -1).split(',')
                    console.log(transform, '矩阵2')
                let rotateWidth = rotateoffsetHeight * matrix[1] + rotateoffsetWidth * matrix[0]
                let rotateHeight = rotateoffsetHeight * matrix[0] + rotateoffsetWidth * matrix[1]
                console.log(route.offsetLeft * matrix[0]+ route.offsetTop * matrix[2] + rotateWidth, 'xxxxxxxxxxx')
                // console.log(Math.abs(rotateWidth), 'paddddddddddddd', Math.abs(rotateHeight))
                // storageMark.width = Math.abs(rotateWidth)
                // storageMark.height = Math.abs(rotateHeight)
                // route.style.transform
                // route.style.width = Math.abs(rotateWidth) + "px"
                // route.style.height = Math.abs(rotateHeight) + "px"
                // transform: matrix(a,b,c,d,e,f);
            }
        }
        // 计算两点的线在页面中的角度
        static angle (centerx, centery, endx, endy) {
            var diff_x = endx - centerx,
                diff_y = endy - centery
            var c = 360 * Math.atan2(diff_y, diff_x) / (2 * Math.PI)
            c = c <= -90 ? (360 + c) : c
            return c + 90
        }
    }
    

    function drop (event) {
        createEl.removeAttribute("draggable")
        drawBox.appendChild(createEl)
        mobile.prototype.drawTable(event, createEl)
    }

    function mouseup(e) {
        if (storageMark != null) {
            storageMark = null
        }
        debug = false
        centerX = 0 // 鼠标松开重新设置x圆点
        centerY = 0 // 鼠标松开重新设置y圆点
    }
    drawBox.onmousedown = mobile.prototype.mousedown
    drawBox.onmouseup = mouseup
    canvas.ondrop = drop
}
/**
 * 鼠标拖动事件
 * @param {*dragStart}
 */
function dragStart (event) {
  let node = event.target
  createEl = node.cloneNode(true)
}
/**
 * 鼠标拖动事件
 * @param {*allowDrop}
 */
function allowDrop (event) {
  event.preventDefault()
}

export default {
  dragStart,
  allowDrop,
  start
}