/**
 * 梯形
 */
export class changeTrapezoidPlace {
    // 梯形左 
    trapezoidLeft (storageMark, xMin, yMin) {
        var leftWidth = Math.max(xMin, storageMark.insideWidth - window.event.clientX + storageMark.grabx)
        storageMark.el.firstElementChild.style.width = leftWidth + 'px'
        storageMark.el.firstElementChild.lastElementChild.style.width = leftWidth - 2 + 'px'
        storageMark.el.style.left = Math.min(storageMark.left + window.event.clientX - storageMark.grabx, storageMark.left + storageMark.width - xMin) + 'px'
        let line = storageMark.el.querySelector('.line')
        line.style.width = leftWidth - 2 + 'px'
        line.style.marginLeft = `-${(leftWidth - 2)/2}px`
    }
    // 梯形top height
    trapezoidTopHeight (storageMark, xMin, yMin) {
        storageMark.el.style.top = Math.min(storageMark.top + window.event.clientY - storageMark.graby, storageMark.top + storageMark.height - yMin) + 'px'
        storageMark.el.firstElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom - window.event.clientY + storageMark.graby) + 'px solid #5b5b5b'
        storageMark.el.firstElementChild.lastElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom - window.event.clientY + storageMark.graby) -2 + 'px solid #fff'
        storageMark.el.style.height = Math.max(yMin, storageMark.height - window.event.clientY + storageMark.graby) + 'px'
    }
    // 梯形左下
    trapezoidBottom (storageMark, xMin, yMin) {
        storageMark.el.style.height = Math.max(yMin, storageMark.height + window.event.clientY - storageMark.graby) + 'px'
        storageMark.el.firstElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom + window.event.clientY - storageMark.graby) + 'px solid #5b5b5b'
        storageMark.el.firstElementChild.lastElementChild.style.borderBottom = Math.max(yMin, storageMark.insideBottom + window.event.clientY - storageMark.graby) -2 + 'px solid #fff'
    }
    // 梯形右宽
    trapezoidRight (storageMark, xMin, yMin) {
        var oWidth = Math.max(xMin, storageMark.insideWidth + window.event.clientX - storageMark.grabx)
        storageMark.el.firstElementChild.style.width = oWidth + 'px'
        storageMark.el.firstElementChild.lastElementChild.style.width = oWidth - 2 + 'px'
        let line = storageMark.el.querySelector('.line')
        line.style.width = oWidth - 2 + 'px'
        line.style.marginLeft = `-${(oWidth - 2)/2}px`
    }
}
// 圆 部分公共坐标
export class changeCircle {
    // 改变左宽度
    circleWidth (storageMark, xMin, yMin, name) {
        var circle_width = Math.max(xMin, storageMark.width - window.event.clientX + storageMark.grabx) + 'px'
        // 这里判断准备在html传递最小值，以作动态判断
        if(parseInt(circle_width) > 100 || name === 'arc'){
            storageMark.el.style.width = circle_width
            storageMark.el.firstElementChild.style.width = circle_width
            storageMark.el.style.left = Math.min(storageMark.left + window.event.clientX - storageMark.grabx, storageMark.left + storageMark.width - xMin) + 'px'
            this.bathtub(storageMark, parseInt(circle_width))
        }
    }
    // 改变右宽
    circleRightWidth (storageMark, xMin, yMin, name) {
        var circle_width = Math.max(xMin, storageMark.width + window.event.clientX - storageMark.grabx) + 'px'
        if(parseInt(circle_width)>108 || name === 'arc'){
            storageMark.el.style.width = circle_width
            storageMark.el.firstElementChild.style.width = circle_width
            this.bathtub(storageMark, parseInt(circle_width))
        }
    }
    // 改变top高度
    circleTopHeight (storageMark, xMin, yMin, name) {
        let height = Math.max(yMin, storageMark.height - window.event.clientY + storageMark.graby) + 'px'
        if(parseInt(height) > 55 || name === 'arc') {
            storageMark.el.style.top = Math.min(storageMark.top + window.event.clientY - storageMark.graby, storageMark.top + storageMark.height - yMin) + 'px'
            storageMark.el.style.height = height
            storageMark.el.firstElementChild.style.height = height
            this.bathtub(storageMark, undefined, parseInt(height))
        }
    }
    // 改变高度
    circleHeight (storageMark, xMin, yMin, name) {
        let height = Math.max(yMin, storageMark.height + window.event.clientY - storageMark.graby) + 'px'
        if (parseInt(height) > 55 || name === 'arc') {
            storageMark.el.style.height = height
            storageMark.el.firstElementChild.style.height = height
            this.bathtub(storageMark, undefined, parseInt(height))
        }
    }
    // 浴缸补丁
    bathtub (storageMark, circle_width, circle_height) {
        if(storageMark.el.firstElementChild.className === 'bath-box') {
            let bathRidge = storageMark.el.firstElementChild.querySelector('.bath-ridge')
                circle_width ? bathRidge.style.width = circle_width < 80 ? 80 : circle_width - 40 + 'px':''
                circle_height ? bathRidge.style.height = circle_height < 36 ? 36 : circle_height - 20 + 'px':''
        }
    }
}
// 获取坐标构造函数
export class getPlaceXY {
    constructor () {
        this.el = null
        this.dir = ""
        this.grabx = null
        this.graby = null
        this.width = null
        this.height = null
        this.left = null
        this.top = null
        this.borderLeft = null
        this.borderRight = null
        this.borderBottom = null
        this.rotate = null
        this.name = null

        // 内圆数据
        this.tableWidth = null
        this.tableTop = null
        this.tableHeight = null
        // 第一个梯形数据
        this.trapezoidOneLeft = null
    }
    // 用于用户移动图形坐标
    getMouseXY (e) {
        var x = 0, y = 0
        e = e || window.event
        if (e.pageX) {
            x = e.pageX
            y = e.pageY
        } else {
            x = e.clientX + drawBox.scrollLeft - drawBox.clientLeft
            y = e.clientY + drawBox.scrollTop - drawBox.clientTop
        }
        return {
            x: x,
            y: y
        }
    }
    // 梯形
    trapezoid (storageMark, n) {
      // 内梯形
      storageMark.insideWidth = parseInt(window.getComputedStyle(n)['width'].split("px").join(''))
      storageMark.insideHeight = parseInt(window.getComputedStyle(n)['height'].split("px").join(''))
      storageMark.insideBottom = parseInt(window.getComputedStyle(n)['border-bottom'])
    }
}